(*let piuuno x =x+1 and piudue x = piuuno (piuuno x) ;; *)(*unbound value piuuno*)

let rec piuuno x =x+1 and piudue x =piuuno (piuuno x) ;; (*ok*)

let rec even n =if n=0 then true else odd(n-1) (*mutua ricorsione*)
and odd n =if n=0 then false else even (n-1);;

let id = fun x -> x and compose f g = fun x -> f (g x);;

let rec iter n f = if n=0 then id else compose f (iter (n-1) f);;
iter 3 (fun (x,y) ->(x,y+1)) (3,2);;

let rec loop p f x = if p(x) then x else (loop p f (f x));;
((loop (fun x -> x>0))(fun x -> x+1))(-3);;

let rec iter n f x = snd(loop(fun(p,x)-> n=p) (fun (p,x)-> (p+1,f x)) (0,x));;

type mionum = Int of int | Float of float;;

let addNum pair = match pair with
    (Int x,Int y) -> Int (x+y)
	  | (Int x, Float y) -> Float ((float_of_int x)+.y)
	  | (Float x, Int y) -> Float (x+.(float_of_int y))
	  | (Float x,Float y) -> Float (x+.y);;


type alberoBin = Foglia of string | Nodo of string * alberoBin * alberoBin ;;

let rec depth x = match x with
    	  Foglia x-> 1
         | Nodo (x,y,z) -> 1+((fun x y -> if x>y then x else y) (depth y) (depth z)) ;;

type 'a bin = Foglia of 'a | Nodo of 'a * 'a bin *'a bin;;

let a=Nodo ("a",Nodo("b",(Foglia "c"),(Foglia "d")), Nodo("e",(Foglia "f"),(Foglia "g")));;

type 'a stack = Stack of 'a list;;

let push s x= match s with
      Stack l -> Stack (x::l);;

let isEmpty s = match s with
      Stack [] -> true
	    |Stack xs -> false;; (*commento*)

let top s = match s with 
    	Stack (x::l) -> x;;

let pop s = match s with 
    	Stack (x::l) -> (x,s);;

type nat = Zero | Nat of int;;

(*Tipi record*)
type razionale ={num:int; den:int};;

let sum r s = {num=r.num*s.den+s.num*r.den; den=r.den*s.den};;

let sum {num=n1;den=d1} {num=n2;den=d2} = {num=n1*d2+n2*d1; den=d1*d2};;

type ('a,'b) razionale ={num:'a; den:'b};;

(*eccezioni*)
let hd xs = match xs with
 [] -> raise (Failure "hd")
| x::ys -> x;;

(*failwith*)
let hd xs = match xs with
 [] -> failwith  "hd"
| x::ys -> x;;

(* try-catch *)
let aTryCatch xs = 
try (hd xs)/0 with 
  Failure x -> 0
  | Division_by_zero ->1;;

let rec length xs = match xs with
     |[] -> 0
     | x::xs -> 1+(length xs);;
let rec append xs ys = match xs with
      | [] -> ys
      | x::xs -> x::(append xs ys);;

let hd (x::xs) = x;;
let tail (x::xs) = xs;;

let rec filter p xs = match xs with
    [] -> []
    |y::ys when (p y) -> y::(filter p ys)
    |y::ys when not (p y) -> filter p ys;;

let rec rev xs = match xs with
    [] -> []
    | x::xs ->(rev xs) @ [x];;

let rec take n xs = match xs with
    [] -> []
    | y::ys when (n>0) -> y:: (take (n-1) ys)
    | y::ys when (n<=0) ->  [];;

let rec map f xs = match xs with
   |[] -> []
   |x::xs -> (f x) :: (map f xs);;

(*associa a destra foldr (+) 0 [1;2;3] calcola 1+(2+(3+0)) *)
let rec foldr p v xs = match xs with
     |[] -> v
     |x::ys -> (p x (foldr p v ys));;


(*associa a sinistra foldl (+) 0 [1;2;3] calcola ((0+1)+2)+3*)
let rec foldl p v xs = match xs with
     |[] -> v
     |x::ys -> foldl p (p v x)  ys;;

let max x y= if (x>y) then x else y;;
let maxL xs = foldl (max) (hd xs) (tail xs);;
let maxL xs = foldl (fun x y -> if (x>y) then x else y) (hd xs) (tail xs);;
